Package: phylolm
Version: 2.6.5
Date: 2024-09-24
Title: Phylogenetic Linear Regression
Authors@R: c(person("Lam Si Tung", "Ho", role=c("aut", "cre"), email="lamho86@gmail.com"),
            person("Cecile", "Ane", role="aut"),
			person("Robert", "Lachlan", role="ctb"),
			person("Kelsey", "Tarpinian",role="ctb"),
      person("Rachel", "Feldman",role="ctb"),
      person("Qing", "Yu",role="ctb"),
      person("Wouter", "van der Bijl",role="ctb"),
      person("Joan", "Maspons",role="ctb"),
      person("Rutger", "Vos",role="ctb"),
      person("Paul", "Bastide",role="ctb"))
Depends: R (>= 3.0), ape
Imports: future.apply
Description: Provides functions for fitting phylogenetic linear models and phylogenetic generalized linear models. The computation uses an algorithm that is linear in the number of tips in the tree. The package also provides functions for simulating continuous or binary traits along the tree. Other tools include functions to test the adequacy of a population tree.
License: GPL (>= 2) | file LICENSE
URL: https://github.com/lamho86/phylolm
BugReports: https://github.com/lamho86/phylolm/issues
Encoding: UTF-8
Packaged: 2024-09-30 13:59:25 UTC; lamho
NeedsCompilation: yes
Suggests: testthat, nlme
Author: Lam Si Tung Ho [aut, cre],
  Cecile Ane [aut],
  Robert Lachlan [ctb],
  Kelsey Tarpinian [ctb],
  Rachel Feldman [ctb],
  Qing Yu [ctb],
  Wouter van der Bijl [ctb],
  Joan Maspons [ctb],
  Rutger Vos [ctb],
  Paul Bastide [ctb]
Maintainer: Lam Si Tung Ho <lamho86@gmail.com>
Repository: CRAN
Date/Publication: 2024-09-30 19:00:02 UTC
Built: R 4.4.2; aarch64-apple-darwin23.2.0; 2024-12-08 00:00:30 UTC; unix

Package: phylolm
Version: 2.6.5
Date: 2024-09-24
Title: Phylogenetic Linear Regression
Authors@R: c(person("Lam Si Tung", "Ho", role=c("aut", "cre"), email="lamho86@gmail.com"),
            person("Cecile", "Ane", role="aut"),
			person("Robert", "Lachlan", role="ctb"),
			person("Kelsey", "Tarpinian",role="ctb"),
      person("Rachel", "Feldman",role="ctb"),
      person("Qing", "Yu",role="ctb"),
      person("Wouter", "van der Bijl",role="ctb"),
      person("Joan", "Maspons",role="ctb"),
      person("Rutger", "Vos",role="ctb"),
      person("Paul", "Bastide",role="ctb"))
Depends: R (>= 3.0), ape
Imports: future.apply
Description: Provides functions for fitting phylogenetic linear models and phylogenetic generalized linear models. The computation uses an algorithm that is linear in the number of tips in the tree. The package also provides functions for simulating continuous or binary traits along the tree. Other tools include functions to test the adequacy of a population tree.
License: GPL (>= 2) | file LICENSE
URL: https://github.com/lamho86/phylolm
BugReports: https://github.com/lamho86/phylolm/issues
Encoding: UTF-8
Packaged: 2024-09-30 13:59:25 UTC; lamho
NeedsCompilation: yes
Suggests: testthat, nlme
Author: Lam Si Tung Ho [aut, cre],
  Cecile Ane [aut],
  Robert Lachlan [ctb],
  Kelsey Tarpinian [ctb],
  Rachel Feldman [ctb],
  Qing Yu [ctb],
  Wouter van der Bijl [ctb],
  Joan Maspons [ctb],
  Rutger Vos [ctb],
  Paul Bastide [ctb]
Maintainer: Lam Si Tung Ho <lamho86@gmail.com>
Repository: CRAN
Date/Publication: 2024-09-30 19:00:02 UTC
Built: R 4.4.2; x86_64-apple-darwin19.6.0; 2024-12-07 06:46:38 UTC; unix

Package: phylolm
Version: 2.6.2
Date: 2020-06-18
Title: Phylogenetic Linear Regression
Authors@R: c(person("Lam Si Tung", "Ho", role=c("aut", "cre"), email="lamho86@gmail.com"),
            person("Cecile", "Ane", role="aut"),
			person("Robert", "Lachlan", role="ctb"),
			person("Kelsey", "Tarpinian",role="ctb"),
      person("Rachel", "Feldman",role="ctb"),
      person("Qing", "Yu",role="ctb"),
      person("Wouter", "van der Bijl",role="ctb"),
      person("Joan", "Maspons",role="ctb"),
      person("Rutger", "Vos",role="ctb"))
Depends: R (>= 4.0), ape
Imports: future.apply
Description: Provides functions for fitting phylogenetic linear models and phylogenetic generalized linear models. The computation uses an algorithm that is linear in the number of tips in the tree. The package also provides functions for simulating continuous or binary traits along the tree. Other tools include functions to test the adequacy of a population tree.
License: GPL (>= 2) | file LICENSE
URL: https://github.com/lamho86/phylolm
BugReports: https://github.com/lamho86/phylolm/issues
Encoding: UTF-8
Packaged: 2020-06-22 02:21:07 UTC; lamho
NeedsCompilation: yes
Suggests: testthat
Author: Lam Si Tung Ho [aut, cre],
  Cecile Ane [aut],
  Robert Lachlan [ctb],
  Kelsey Tarpinian [ctb],
  Rachel Feldman [ctb],
  Qing Yu [ctb],
  Wouter van der Bijl [ctb],
  Joan Maspons [ctb],
  Rutger Vos [ctb]
Maintainer: Lam Si Tung Ho <lamho86@gmail.com>
Repository: CRAN
Date/Publication: 2020-06-22 05:10:08 UTC
Built: R 4.0.3; x86_64-w64-mingw32; 2020-12-14 08:47:55 UTC; windows
Archs: x64

useDynLib(phylolm, .registration = TRUE)

exportPattern("^[[:alpha:]]+")

import(ape)
import(future.apply)

importFrom("graphics", "abline", "axis", "barplot", "layout", "plot")
importFrom("stats", "AIC", "add.scope", "binomial", "coef",
             "delete.response", "drop.scope", "fitted", "formula", "glm",
             "logLik", "model.frame", "model.matrix", "model.response",
             "optim", "pnorm", "poisson", "printCoefmat", "pt",
             "quantile", "reorder", "rnorm", "runif", "sd", "terms",
             "var", "nobs", "confint", "cor")
importFrom("graphics", "hist", "mtext", "points")
importFrom("stats", "chisq.test", "optimize", "pbeta")
importFrom("utils", "flush.console")

S3method(AIC,logLik.phyloglm)
S3method(AIC,logLik.phylolm)
S3method(AIC, phyloglm)
S3method(AIC, phylolm)
S3method(extractAIC, phylolm)
S3method(logLik, phyloglm)
S3method(logLik, phylolm)
S3method(nobs, phylolm)
S3method(nobs, phyloglm)
S3method(plot, OUshifts)
S3method(plot, phyloglm)
S3method(plot, phylolm)
S3method(predict, phylolm)
S3method(print, logLik.phyloglm)
S3method(print, logLik.phylolm)
S3method(print, phyloglm)
S3method(print, phylolm)
S3method(print, summary.phyloglm)
S3method(print, summary.phylolm)
S3method(residuals, phyloglm)
S3method(residuals, phylolm)
S3method(summary, phyloglm)
S3method(summary, phylolm)
S3method(vcov, phyloglm)
S3method(vcov, phylolm)
S3method(confint, phylolm)
S3method(model.frame, phylolm)

useDynLib(phylolm, .registration = TRUE)

exportPattern("^[[:alpha:]]+")

import(ape)
import(future.apply)

importFrom("graphics", "abline", "axis", "barplot", "layout", "plot")
importFrom("stats", "AIC", "add.scope", "binomial", "coef",
             "delete.response", "drop.scope", "fitted", "formula", "glm",
             "logLik", "model.frame", "model.matrix", "model.response",
             "optim", "pnorm", "poisson", "printCoefmat", "pt",
             "quantile", "reorder", "rnorm", "runif", "sd", "terms",
             "var", "nobs")
importFrom("graphics", "hist", "mtext", "points")
importFrom("stats", "chisq.test", "optimize", "pbeta")
importFrom("utils", "flush.console")

S3method(AIC,logLik.phyloglm)
S3method(AIC,logLik.phylolm)
S3method(AIC, phyloglm)
S3method(AIC, phylolm)
S3method(extractAIC, phylolm)
S3method(logLik, phyloglm)
S3method(logLik, phylolm)
S3method(nobs, phylolm)
S3method(plot, OUshifts)
S3method(plot, phyloglm)
S3method(plot, phylolm)
S3method(predict, phylolm)
S3method(print, logLik.phyloglm)
S3method(print, logLik.phylolm)
S3method(print, phyloglm)
S3method(print, phylolm)
S3method(print, summary.phyloglm)
S3method(print, summary.phylolm)
S3method(residuals, phyloglm)
S3method(residuals, phylolm)
S3method(summary, phyloglm)
S3method(summary, phylolm)
S3method(vcov, phyloglm)
S3method(vcov, phylolm)

test_that("REML estimates", {
  skip_if_not_installed("nlme")

  ## Taken from example
  set.seed(123456)
  tre = rphylo(60, 0.1, 0.01)
  tre_h <- max(vcv(tre))
  taxa = sort(tre$tip.label)
  b0 = 0; b1 = 1; b2 = -2;
  x <- rTrait(n = 1, phy = tre, model = "BM",
              parameters = list(ancestral.state = 0, sigma2 = 10))
  f <- sample(c(0, 1), length(taxa), replace = TRUE)
  names(f) <- names(x)
  y <- b0 + b1*x + b2 * f +
    rTrait(n = 1, phy = tre, model = "lambda",
           parameters = list(
             ancestral.state = 0, sigma2 = 1, lambda = 0.5))
  # adding measurement errors
  z <- y + rnorm(length(taxa), 0, 1)
  dat = data.frame(trait = z[taxa], pred = x[taxa], fac = as.factor(f[taxa]), species = taxa)

  ## Fit - BM - ML
  fit = phylolm(trait ~ pred + fac, data = dat, phy = tre, model = "BM")
  fit_gls <- nlme::gls(trait ~ pred + fac, data = dat, correlation = corBrownian(1, tre, form = ~species), method = "ML")

  expect_equal(as.numeric(logLik(fit)), fit_gls$logLik)
  expect_equal(fit$coefficients, fit_gls$coefficients)
  expect_equal(fit$vcov, fit_gls$varBeta)
  expect_equal(fit$n, fit_gls$dims$N)
  expect_equal(fit$d, fit_gls$dims$p)
  expect_equal(summary(fit)$coefficients[, "t.value"], summary(fit_gls)$tTable[, "t-value"])
  expect_equal(fit$fitted[taxa], fit_gls$fitted[taxa])
  expect_equal(fit$residuals[taxa], fit_gls$residuals[taxa])
  expect_equal(AIC(fit), AIC(fit_gls))
  expect_equal(as.numeric(logLik(fit)), as.numeric(logLik(fit_gls)))
  expect_equal(fit$sigma2, fit_gls$sigma^2 / tre_h)

  ## Fit - BM - REML
  fit = phylolm(trait ~ pred, data = dat, phy = tre, model = "BM", REML = TRUE)
  fit_gls <- nlme::gls(trait ~ pred, data = dat, correlation = corBrownian(1, tre, form = ~species), method = "REML")

  expect_equal(as.numeric(logLik(fit)), fit_gls$logLik)
  expect_equal(fit$coefficients, fit_gls$coefficients)
  expect_equal(fit$vcov, fit_gls$varBeta)
  expect_equal(fit$n, fit_gls$dims$N)
  expect_equal(fit$d, fit_gls$dims$p)
  expect_equal(summary(fit)$coefficients[, "t.value"], summary(fit_gls)$tTable[, "t-value"])
  expect_equal(fit$fitted[taxa], fit_gls$fitted[taxa])
  expect_equal(fit$residuals[taxa], fit_gls$residuals[taxa])
  expect_equal(AIC(fit), AIC(fit_gls))
  expect_equal(as.numeric(logLik(fit)), logLik(fit_gls)[1])
  expect_equal(fit$sigma2, fit_gls$sigma^2 / tre_h)

  ## Fit - lambda - ML
  fit = phylolm(trait ~ pred + fac, data = dat, phy = tre, model = "lambda")
  fit_gls <- nlme::gls(trait ~ pred + fac, data = dat, correlation = corPagel(1, tre, form = ~species), method = "ML")

  expect_equal(as.numeric(logLik(fit)), fit_gls$logLik)
  expect_equal(fit$coefficients, fit_gls$coefficients, tolerance = 1e-5)
  expect_equal(fit$vcov, fit_gls$varBeta, tolerance = 1e-5)
  expect_equal(fit$n, fit_gls$dims$N)
  expect_equal(fit$d, fit_gls$dims$p)
  expect_equal(summary(fit)$coefficients[, "t.value"], summary(fit_gls)$tTable[, "t-value"], tolerance = 1e-5)
  expect_equal(fit$fitted[taxa], fit_gls$fitted[taxa], tolerance = 1e-5)
  expect_equal(fit$residuals[taxa], fit_gls$residuals[taxa], tolerance = 1e-5)
  expect_equal(AIC(fit), AIC(fit_gls))
  expect_equal(as.numeric(logLik(fit)), logLik(fit_gls)[1])
  expect_equal(fit$optpar, fit_gls$modelStruct$corStruct[1], tolerance = 1e-5)
  expect_equal(fit$sigma2, fit_gls$sigma^2 / tre_h, tolerance = 1e-5)

  ## Fit - lambda - REML
  fit = phylolm(trait ~ pred, data = dat, phy = tre, model = "lambda", REML = TRUE)
  fit_gls <- nlme::gls(trait ~ pred, data = dat, correlation = corPagel(1, tre, form = ~species), method = "REML")

  expect_equal(fit$logLik, fit_gls$logLik)
  expect_equal(fit$coefficients, fit_gls$coefficients, tolerance = 1e-6)
  expect_equal(fit$vcov, fit_gls$varBeta, tolerance = 1e-6)
  expect_equal(fit$n, fit_gls$dims$N)
  expect_equal(fit$d, fit_gls$dims$p)
  expect_equal(summary(fit)$coefficients[, "t.value"], summary(fit_gls)$tTable[, "t-value"], tolerance = 1e-6)
  expect_equal(fit$fitted[taxa], fit_gls$fitted[taxa], tolerance = 1e-6)
  expect_equal(fit$residuals[taxa], fit_gls$residuals[taxa], tolerance = 1e-6)
  expect_equal(AIC(fit), AIC(fit_gls))
  expect_equal(as.numeric(logLik(fit)), logLik(fit_gls)[1])
  expect_equal(fit$optpar, fit_gls$modelStruct$corStruct[1], tolerance = 1e-6)
  expect_equal(fit$sigma2, fit_gls$sigma^2 / tre_h, tolerance = 1e-6)

  ## Fit - OU - ML
  fit = phylolm(trait ~ pred + fac, data = dat, phy = tre, model = "OUrandomRoot")
  fit_gls <- nlme::gls(trait ~ pred + fac, data = dat, correlation = corMartins(0.1, tre, form = ~species), method = "ML")

  expect_equal(fit$logLik, fit_gls$logLik)
  expect_equal(fit$coefficients, fit_gls$coefficients, tolerance = 1e-6)
  expect_equal(fit$vcov, fit_gls$varBeta, tolerance = 1e-6)
  expect_equal(fit$n, fit_gls$dims$N)
  expect_equal(fit$d, fit_gls$dims$p)
  expect_equal(summary(fit)$coefficients[, "t.value"], summary(fit_gls)$tTable[, "t-value"], tolerance = 1e-5)
  expect_equal(fit$fitted[taxa], fit_gls$fitted[taxa], tolerance = 1e-6)
  expect_equal(fit$residuals[taxa], fit_gls$residuals[taxa], tolerance = 1e-6)
  expect_equal(AIC(fit), AIC(fit_gls))
  expect_equal(as.numeric(logLik(fit)), logLik(fit_gls)[1])
  expect_equal(fit$optpar, fit_gls$modelStruct$corStruct[1], tolerance = 1e-6)
  expect_equal(fit$sigma2 / 2 / fit$optpar, fit_gls$sigma^2, tolerance = 1e-6)

  ## Fit - OU - REML
  fit = phylolm(trait ~ pred, data = dat, phy = tre, model = "OUrandomRoot", REML = TRUE)
  fit_gls <- nlme::gls(trait ~ pred, data = dat, correlation = corMartins(0.1, tre, form = ~species), method = "REML")

  expect_equal(fit$logLik, fit_gls$logLik)
  expect_equal(fit$coefficients, fit_gls$coefficients, tolerance = 1e-6)
  expect_equal(fit$vcov, fit_gls$varBeta, tolerance = 1e-6)
  expect_equal(fit$n, fit_gls$dims$N)
  expect_equal(fit$d, fit_gls$dims$p)
  expect_equal(summary(fit)$coefficients[, "t.value"], summary(fit_gls)$tTable[, "t-value"], tolerance = 1e-5)
  expect_equal(fit$fitted[taxa], fit_gls$fitted[taxa], tolerance = 1e-6)
  expect_equal(fit$residuals[taxa], fit_gls$residuals[taxa], tolerance = 1e-6)
  expect_equal(AIC(fit), AIC(fit_gls))
  expect_equal(as.numeric(logLik(fit)), logLik(fit_gls)[1])
  expect_equal(fit$optpar, fit_gls$modelStruct$corStruct[1], tolerance = 1e-6)
  expect_equal(fit$sigma2 / 2 / fit$optpar, fit_gls$sigma^2, tolerance = 1e-6)

})

test_that("Test confint", {
  set.seed(12891026)
  ## Tree
  ntips <- 10
  tree <- ape::rphylo(ntips, 0.1, 0)
  ## data
  y_data <- phylolm::rTrait(1, tree, model = "BM", parameters = list(sigma2 = 1))
  ## Condition
  cond <- sample(c(0, 1), ntips, replace = TRUE)
  names(cond) <- tree$tip.label
  y_data[cond == 1] <- y_data[cond == 1] + 5 ## strong effect

  ## Fit
  fit <- phylolm(y_data ~ cond, phy = tree)

  ## Confidence Interval
  level <- 0.95
  ci <- confint(fit, level = level)

  ## Confidence Interval - Manual
  quants <- c((1 - level) / 2, 1 - (1 - level) / 2)
  ci_manual <- coef(fit) + summary(fit)$coefficients[, 2] %o% qt(quants, fit$n - fit$d)

  ## Equal
  expect_equivalent(ci, ci_manual)

  ## One parameter at a time, changing level
  level <- 0.90
  ci <- confint(fit, parm = "cond", level = level)
  quants <- c((1 - level) / 2, 1 - (1 - level) / 2)
  ci_manual <- coef(fit)[2] + summary(fit)$coefficients[2, 2] * qt(quants, fit$n - fit$d)
  expect_equivalent(ci, ci_manual)
})

library(testthat)

test_that("Log likelihood of 1d OU model",
{
  
  n = 100
  tr = rtree(n) # tree
  vcv.mat = vcv.phylo(tr)
  pat.dist.mat = cophenetic(tr)
  root.to.tip = diag(vcv.mat)
  alpha = 1
  sigma2 = 1
  sigma2_error = 0.5
  ancestral.state = 0
  optimal.value = 1
  
  trait = rTrait(n = 1, tr, model = "OU", 
                           parameters = list(ancestral.state=ancestral.state, alpha=alpha,
                                             sigma2=sigma2,sigma2_error=sigma2_error,
                                             optimal.value=optimal.value))
  root.to.tip <- diag(vcv.mat)
  X = (1-exp(-alpha * root.to.tip))*optimal.value + exp(-alpha * root.to.tip)*ancestral.state
  names(X) = names(trait)
  
  V = sigma2/2/alpha *(1 - exp(-2*alpha*vcv.mat)) * exp(-alpha * pat.dist.mat) + sigma2_error * diag(n) 
  
  loglik = as.numeric(- (n*log(2*pi) + log(det(V)) + t(trait-X)%*%solve(V)%*%(trait-X))/2)
  
  OUloglik = OU1d.loglik(trait=trait, phy=tr, model="OUfixedRoot", 
                         parameters=list(ancestral.state=ancestral.state, alpha=alpha,sigma2=sigma2,
                                         sigma2_error=sigma2_error,optimal.value=optimal.value))
  expect_equal(0.0,abs(loglik-OUloglik), 1E-10)
  
}
          )

test_that("Multivariate Response throws an error", {
  set.seed(12891026)
  ## Tree
  ntips <- 10
  tree <- ape::rphylo(ntips, 0.1, 0)
  ## multivariate data
  ntraits <- 2
  y_data <- phylolm::rTrait(ntraits, tree, model = "BM", parameters = list(sigma2 = 1))
  ## Condition
  cond <- sample(c(0, 1), ntips, replace = TRUE)
  names(cond) <- tree$tip.label
  y_data[cond == 1, ] <- y_data[cond == 1, ] + 5 ## strong effect
  ## Data frame
  all_dat <- data.frame(y = y_data, cond = cond)

  ## Univariate fits (various specifications, all equal)
  fit1 <- phylolm(y_data[, 1] ~ cond, phy = tree)
  fit2 <- phylolm(y_data[, 1, drop = FALSE] ~ cond, phy = tree)
  fit3 <- phylolm(y.1 ~ cond, phy = tree, data = all_dat)

  expect_equal(fit1[!(names(fit1) %in% c("call", "formula", "model.frame"))],
               fit2[!(names(fit1) %in% c("call", "formula", "model.frame"))])
  expect_equal(fit1[!(names(fit1) %in% c("call", "formula", "model.frame"))],
               fit3[!(names(fit1) %in% c("call", "formula", "model.frame"))])

  ## Multivariate fits throw errors
  expect_error(phylolm(y_data ~ cond, phy = tree),
               "'phylolm' can only handle a simple \\(univariate\\) response vector y.")

  expect_error(phylolm(cbind(y.1, y.2) ~ cond, phy = tree, data = all_dat),
               "'phylolm' can only handle a simple \\(univariate\\) response vector y.")
})

test_that("Setting upper, lower and starting values", {
  ## Taken from example
  set.seed(123456)
  tre = rcoal(60)
  taxa = sort(tre$tip.label)
  b0=0; b1=1;
  x <- rTrait(n=1, phy=tre,model="BM",
              parameters=list(ancestral.state=0,sigma2=10))
  y <- b0 + b1*x +
    rTrait(n=1,phy=tre,model="lambda",parameters=list(
      ancestral.state=0,sigma2=1,lambda=0.5))
  # adding measurement errors and bootstrap
  z <- y + rnorm(60,0,1)
  dat = data.frame(trait=z[taxa],pred=x[taxa])

  ## Fit - Fixed values
  fit = phylolm(trait~pred,data=dat,phy=tre,model="lambda",
                starting.value = list(lambda = 0.5),
                upper.bound = list(lambda = 0.5),
                lower.bound = list(lambda = 0.5))

  expect_equal(fit$optpar, 0.5)

  ## Fit - Fixed values - unnamed (backward compatibility)
  fit = phylolm(trait~pred,data=dat,phy=tre,model="lambda",
                starting.value = 0.5,
                upper.bound = 0.5,
                lower.bound = 0.5)

  expect_equal(fit$optpar, 0.5)

  ## Fit - bounds
  fit <- expect_warning(phylolm(trait~pred,data=dat,phy=tre,model="kappa",
                                starting.value = list(kappa = 0.5),
                                upper.bound = list(kappa = 2),
                                lower.bound = list(kappa = 0.2)),
                        "the estimation of kappa matches the upper/lower bound for this parameter")
  
  expect_true(fit$optpar <= 2)
  expect_true(fit$optpar >= 0.2)

  ## Fit - bounds default
  fit <- expect_warning(phylolm(trait~pred,data=dat,phy=tre,model="kappa",
                                starting.value = list(kappa = 0.5),
                                upper.bound = list(kappa = 2)),
                        "the estimation of kappa matches the upper/lower bound for this parameter")
  
  expect_true(fit$optpar <= 2)
  expect_true(fit$optpar >= 10^{-6}) ## default lower bound

  ## Fit - bounds - measurement error
  fit <- expect_warning(phylolm(trait~pred,data=dat,phy=tre,model="BM", measurement_error = TRUE,
                                starting.value = list(sigma2_error = 0.5),
                                upper.bound = list(sigma2_error = 0.51),
                                lower.bound = list(sigma2_error = 0.49)),
                        "the estimation of sigma2_error matches the upper/lower bound for this parameter")

  expect_true(fit$sigma2_error <= 0.51 * fit$sigma2)
  expect_true(fit$sigma2_error >= 0.49 * fit$sigma2)

  ## Fit - bounds - measurement error
  expect_warning(phylolm(trait~pred,data=dat,phy=tre,model="OUfixedRoot", measurement_error = TRUE,
                         starting.value = list(alpha = 1, sigma2_error = 0.5),
                         upper.bound = list(alpha = 1, sigma2_error = 0.51),
                         lower.bound = list(alpha = 1, sigma2_error = 0.49)),
                 "the estimation of alpha matches the upper/lower bound for this parameter")
  fit <- expect_warning(phylolm(trait~pred,data=dat,phy=tre,model="OUfixedRoot", measurement_error = TRUE,
                                starting.value = list(alpha = 1, sigma2_error = 0.5),
                                upper.bound = list(alpha = 1, sigma2_error = 0.51),
                                lower.bound = list(alpha = 1, sigma2_error = 0.49)),
                        "the estimation of sigma2_error matches the upper/lower bound for this parameter")

  expect_true(fit$sigma2_error <= 0.51 * fit$sigma2 / (2 * 1))
  expect_true(fit$sigma2_error >= 0.49 * fit$sigma2 / (2 * 1))
  expect_equal(fit$optpar, 1)

  ## Fit - bounds - measurement error
  expect_warning(phylolm(trait~pred,data=dat,phy=tre,model="OUfixedRoot", measurement_error = TRUE,
                         starting.value = list(alpha = 0.5, sigma2_error = 0.5),
                         upper.bound = list(alpha = 0.6, sigma2_error = 0.55),
                         lower.bound = list(alpha = 0.4, sigma2_error = 0.49)),
                 "the estimation of alpha matches the upper/lower bound for this parameter")
  fit <- expect_warning(phylolm(trait~pred,data=dat,phy=tre,model="OUfixedRoot", measurement_error = TRUE,
                                starting.value = list(alpha = 0.5, sigma2_error = 0.5),
                                upper.bound = list(alpha = 0.6, sigma2_error = 0.55),
                                lower.bound = list(alpha = 0.4, sigma2_error = 0.49)),
                        "the estimation of sigma2_error matches the upper/lower bound for this parameter")

  expect_true(fit$sigma2_error <= 0.55 * fit$sigma2 / (2 * fit$optpar) + 1e-8)
  expect_true(fit$sigma2_error >= 0.49 * fit$sigma2 / (2 * fit$optpar) + 1e-8)
  expect_true(fit$optpar <= 0.6)
  expect_true(fit$optpar >= 0.4)

  ## Fit - default bounds - measurement error
  fit = phylolm(trait~pred,data=dat,phy=tre,model="delta", measurement_error = TRUE,
                starting.value = list(delta = 0.5, sigma2_error = 5 * 10^{15}),
                upper.bound = list(delta = 0.6),
                lower.bound = list(delta = 0.4, sigma2_error = 10^{15}))

  expect_true(fit$sigma2_error <= 10^{16} * fit$sigma2 / (2 * fit$optpar))
  expect_true(fit$sigma2_error >= 10^{15} * fit$sigma2 / (2 * fit$optpar))
  expect_true(fit$optpar <= 0.6)
  expect_true(fit$optpar >= 0.4)

  ## Fit - default bounds - measurement error - unnamed length one (backward compatibility)
  fit <- expect_warning(phylolm(trait~pred,data=dat,phy=tre,model="OUrandomRoot", measurement_error = TRUE,
                                starting.value = 0.5,
                                upper.bound = 0.5,
                                lower.bound = 0.5),
                        "the estimation of alpha matches the upper/lower bound for this parameter")

  expect_true(fit$sigma2_error <= 10^{16} * fit$sigma2 / (2 * fit$optpar))
  expect_true(fit$sigma2_error >= 10^{-16} * fit$sigma2 / (2 * fit$optpar))
  expect_equal(fit$optpar, 0.5)

  ## Fit - BM - unnamed length one
  fit = phylolm(trait~pred,data=dat,phy=tre,model="BM", measurement_error = FALSE,
                starting.value = 0.5,
                upper.bound = 0.5,
                lower.bound = 0.5)

  expect_equal(fit$sigma2_error, 0.0)
  expect_equal(fit$optpar, NULL)

  ## Fit - BM
  fit = phylolm(trait~pred,data=dat,phy=tre,model="BM", measurement_error = FALSE,
                starting.value = list(sigma2_error = 0.5),
                upper.bound = list(sigma2_error = 0.5),
                lower.bound = list(sigma2_error = 0.5))

  expect_equal(fit$sigma2_error, 0.0)
  expect_equal(fit$optpar, NULL)

})
